function MergingChests.CreateChestItems(size)
	local nameH = "wide-chest-"..size
	local nameV = "high-chest-"..size
	
	return
	{
		{
			type = "item",
			name = nameH,
			localised_name = {"chest-name.wide-chest", size},
			icon = "__base__/graphics/icons/"..MergingChests.MergableChestId..".png",
			icon_size = 32,
			flags = {"goes-to-quickbar", "hidden"},
			subgroup = "storage",
			order = "d[items]-b[wide-chest]-"..string.format("%02d", size),
			place_result = nameH,
			stack_size = 50
		},
		{
			type = "item",
			name = nameV,
			localised_name = { "chest-name.high-chest", size },
			icon = "__base__/graphics/icons/"..MergingChests.MergableChestId..".png",
			icon_size = 32,
			flags = { "goes-to-quickbar", "hidden" },
			subgroup = "storage",
			order = "d[items]-b[high-chest]-"..string.format("%02d", size),
			place_result = nameV,
			stack_size = 50
		}
	}
end

for i = 2, settings.startup["max-chest-size"].value do
	data:extend(MergingChests.CreateChestItems(i))
end

data:extend(
{
	{
		type = "selection-tool",
		name = "merge-chest-selector",
		icon = "__WideChests__/graphics/icons/merge-chest-selector.png",
		icon_size = 32,
		flags = { "goes-to-quickbar" },
		subgroup = "tool",
		order = "c[automated-construction]-a[blueprint]",
		stack_size = 1,
		draw_label_for_cursor_render = true,
		selection_color = { r = 0, g = 0, b = 1 },
		alt_selection_color = { r = 1, g = 0, b = 0 },
		selection_mode = { "blueprint", "matches-force" },
		alt_selection_mode = { "blueprint", "matches-force" },
		selection_cursor_box_type = "entity",
		alt_selection_cursor_box_type = "entity"
	},
})