if not MergingChests then MergingChests = { } end

require("lookup")

local allowedChests = { }
for name, id in pairs(MergingChests.MergableChestNameToId) do
	table.insert(allowedChests, name)
end

data:extend(
{
	{
		name = "mergable-chest-name",
		type = "string-setting",
		setting_type = "startup",
		default_value = MergingChests.MergableChestIdToName["steel-chest"],
		allowed_values = allowedChests,
		per_user = false,
		order = "1"
	},
	{
		name = "max-chest-size",
		type = "int-setting",
		setting_type = "startup",
		minimum_value = 2,
		default_value = 42,
		per_user = false,
		order = "2"
	},
	{
		name = "inventory-size-multiplier",
		type = "double-setting",
		setting_type = "startup",
		minimum_value = 0,
		default_value = 1.0,
		per_user = false,
		order = "3"
	},
	{
		name = "inventory-size-limit",
		type = "int-setting",
		setting_type = "startup",
		minimum_value = 1,
		default_value = 2016,
		per_user = false,
		order = "4"
	},
})


