
local lab_inputs = {}

local has_input  = function(tab)
	local  found = false
	for _, li in pairs(lab_inputs) do
		local has_all = true
		for _,e in pairs(tab) do
			if not omni.lib.is_in_table(e,li) then
				has_all=false
				break
			end
		end
		if has_all then
			found = true
			break
		end
	end
	return found
end
local compressed_techs={}

for _, lab in pairs(data.raw.lab) do
	local l = table.deepcopy(lab)
	if not has_input(lab.inputs) then
		lab_inputs[#lab_inputs+1]=lab.inputs
	end
	for _, ing in pairs(lab.inputs) do
		if not omni.lib.start_with(ing,"compressed") and not omni.lib.is_in_table("compressed-"..ing,lab.inputs) then
			table.insert(lab.inputs,"compressed-"..ing)
		end
	end
	--compressed_techs[#compressed_techs+1]=l
end

local input_lcm = {}

for i, li in pairs(lab_inputs) do
	local lcm = 1
	for _,pack in pairs(li) do
		local item = data.raw.tool[pack]
		lcm = omni.lib.lcm(lcm,item.stack_size)
	end
	input_lcm[i]=lcm
end

for _,tech in pairs(data.raw.technology) do
	if tech.unit and ((tech.unit.count and tech.unit.count > 10000) or not tech.unit.count) then
		local t = table.deepcopy(tech)
		t.name=t.name.."-omnipressed"
		t.localised_name = "technology-name."..tech.name
		local lcm = 1
		for _, ing in pairs(t.unit.ingredients) do
			local item = data.raw.tool[ing[1]]
			lcm=omni.lib.lcm(lcm,ing[2]*item.stack_size)
		end
		for _, ing in pairs(t.unit.ingredients) do
			local item = data.raw.tool[ing[1]]
			ing[2]=lcm/(ing[2]*item.stack_size)
			ing[1]="compressed-"..ing[1]
		end
		if t.effects then
			for i, eff in pairs(t.effects) do
				if eff.type ~= "unlock-recipe" then t.effects[i] = nil end
			end
		end
		if t.unit.count then
			t.unit.count = math.floor(t.unit.count/lcm)+1
		else
			t.unit.count_formula = t.unit.count_formula.."*"..(math.floor(10000/lcm)/1000).."+1"
		end
		t.unit.time = t.unit.time*lcm
		compressed_techs[#compressed_techs+1]=table.deepcopy(t)
	end
end
data:extend(compressed_techs)