local water_levels = settings.startup["water-levels"].value
local tier_levels = settings.startup["omnimatter-fluid-lvl-per-tier"].value

function get_tier_mult(levels, r,c)
	local peak = math.floor(levels/2)+1
	--log(levels..":"..r..":"..c)
	if r==1 and c==1 then
		return 1
	elseif r==c and r<=peak then
		return omni.pure_tech_level_increase
	elseif r>peak and c==2*peak-r+tier_levels%2 then
		if  r==3*omni.pure_levels_per_tier then
			return omni.pure_tech_level_increase
		else
			return -omni.pure_tech_level_increase
		end
	else
		return get_tier_mult(levels,r-1,c)+get_tier_mult(levels,r,c+1)
	end
end


local watering={}



local get_solvation_tech_cost = function(lvl)
	local c = {}
	local size = 2+((lvl-1)-(lvl-1)%tier_levels)/tier_levels
	local length = math.min(size,#sciencepacks)
	for l=1,length do
		c[#c+1] = {sciencepacks[l],1}
	end
	return c
end

local omniwater_prereq = function(levels,grade,element,tier)
	local req = {}
	if grade> 1 then
		req[#req+1]="omnitech-"..element.."-omnitraction-"..grade-1
	end
	if grade%tier_levels==1 and (math.floor((grade-1)/tier_levels)+1)<=omni.max_tier then
		req[#req+1]="omnitractor-electric-"..math.min((math.floor((grade-1)/tier_levels)+tier),omni.max_tier)
	end
	return req
end

local cat = "chemistry"
if mods["omnimatter_crystal"] then cat = "omniplant" end

function omniwateradd(element,gain,tier,const)
	local cost = OmniGen:create():
		setInputAmount(12):
		setYield(element):
		setIngredients("omnite"):
		setWaste("omnic-waste"):
		yieldQuant(function(levels,grade) return gain+(grade-1)*gain/(levels-1) end):
		wasteQuant(function(levels,grade) return gain-(grade-1)*gain/(levels-1) end)

	RecChain:create("omnimatter",element):
		setIngredients("omnite"):
		setIcons(element):
		setIngredients(cost:ingredients()):
		setResults(cost:results()):
		setEnabled(false):
		setCategory(cat):
		setSubgroup("omnifluids"):
		setMain("water"):
		setLevel(water_levels):
		setEnergy(5):
		setTechIcon("omnimatter_water",element):
		setTechSuffix("omnitraction"):
		setTechCost(function(levels,grade) return const*get_tier_mult(levels,grade,1) end):
		setTechPrereq(function(levels,grade) return omniwater_prereq(levels,grade,"water",tier)  end):
		setTechTime(15):
		setTechLocName("water-based-omnitraction",{"fluid-name."..element}):
		extend()
end

omniwateradd("water",1728,1,72)
		

if mods["angelsrefining"] then 
	omniwateradd("water-viscous-mud",1728,1,244)
	for _,fluid in pairs(data.raw.fluid) do
		if omni.lib.start_with(fluid.name,"water") and omni.lib.end_with(fluid.name,"waste") then
			omniwateradd(fluid.name,720,2,288)
		end
	end
end